## madness 0.10.1~gite4aa500e

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.0)
project(MADNESS CXX C ASM)

# Check CMake version
if(CMAKE_VERSION VERSION_LESS 3.5.1)  
  message("WARNING: If parallel build fails halfway through, reduce the value of the parallel build to 'make -j 4'. Or try upgrading to CMake 3.5.1.")
endif()

# Set MADNESS version
set(MADNESS_MAJOR_VERSION 0)
set(MADNESS_MINOR_VERSION 10)
set(MADNESS_MICRO_VERSION 1)
set(MADNESS_VERSION "${MADNESS_MAJOR_VERSION}.${MADNESS_MINOR_VERSION}.${MADNESS_MICRO_VERSION}")

# Add module directory and modules =============================================

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules/")
include(AppendFlags)
include(CheckCXX11Support)
include(CheckIncludeFile)
include(CheckTypeSize)
include(CheckCXXSourceCompiles)
include(CheckFunctionExists)
include(CMakeDependentOption)
include(AddUnittests)
include(AddMADLibrary)
include(CMakePackageConfigHelpers)
include(CopyTargetProperties)
include(FeatureSummary)

# Set install paths ============================================================

set(MADNESS_INSTALL_BINDIR "bin" 
    CACHE PATH "MADNESS binary install directory")
set(MADNESS_INSTALL_INCLUDEDIR "include" 
    CACHE PATH "MADNESS INCLUDE install directory")
set(MADNESS_INSTALL_LIBDIR "lib"
    CACHE PATH "MADNESS LIB install directory")
set(MADNESS_INSTALL_DATADIR "share/madness/${MADNESS_VERSION}/data"
    CACHE PATH "MADNESS DATA install directory")
# TODO this matches Automake value, should be adjusted to the convention: share/madness/${MADNESS_VERSION}/doc
set(MADNESS_INSTALL_DOCDIR "share/doc/madness"
    CACHE PATH "MADNESS DOC install directory")
set(MADNESS_INSTALL_CMAKEDIR "lib/cmake/madness"
    CACHE PATH "MADNESS CMAKE install directory")

# Enable optional libraries ====================================================

# Always search for libraries that are 'ON' by default. If a library is not
# found, it is disable without error. If the library is 'OFF' by default,
# failure to find the library is an error. 

option(ENABLE_MPI "Enable Message Passing Interface (MPI) Library" ON)
option(ENABLE_MKL "Search for Intel Math Kernel Library (MKL) for BLAS and LAPACK support" ON)
option(ENABLE_ACML "Search for AMD Core Math Library (ACML) for BLAS and LAPACK support" ON)
option(ENABLE_TCMALLOC_MINIMAL "Enable use of tcmalloc_minimal library from Google Performance Tools (gperftools)" OFF)
cmake_dependent_option(ENABLE_GPERFTOOLS "Enable use of Google Performance Tools (gperftools)" ON
    "NOT ENABLE_TCMALLOC_MINIMAL" OFF)
option(ENABLE_LIBXC "Enables use of the libxc library of density functionals" ON)
option(ENABLE_PAPI "Enables use of PAPI" OFF)

option(ENABLE_TBB "Enables use of Intel Thread Building Blocks (TBB) as the task scheduler" ON)
option(ENABLE_PARSEC "Enables use of PaRSEC as the task scheduler" OFF)
if(ENABLE_PARSEC AND ENABLE_TBB)
  message(FATAL_ERROR "TBB and PaRSEC cannot be both enabled.")
endif()

option(ENABLE_ELEMENTAL "Enable Elemental library for distributed-memory linear algebra" OFF)
if (ENABLE_ELEMENTAL)
  if (DEFINED ELEMENTAL_TAG)
    if("${ELEMENTAL_TAG}" STREQUAL "")
      message(FATAL_ERROR "Invalid value given for ELEMENTAL_TAG; specify a valid hash or tag.")
    endif()
    message(STATUS "Will compile Elemental source (tag=${ELEMENTAL_TAG}) in the build directory")
    set(ENABLE_ELEMENTAL_EMBEDDED OFF)
    set(MADNESS_HAS_ELEMENTAL_EMBEDDED 0)
  else (DEFINED ELEMENTAL_TAG)
    message(STATUS "Will use the embedded Elemental source(tag=v0.84)")
    set(ENABLE_ELEMENTAL_EMBEDDED ON)
    set(MADNESS_HAS_ELEMENTAL_EMBEDDED 1)
  endif (DEFINED ELEMENTAL_TAG)
  set(MADNESS_HAS_ELEMENTAL 1)
else (ENABLE_ELEMENTAL)
  set(MADNESS_HAS_ELEMENTAL 0)
endif (ENABLE_ELEMENTAL)
add_feature_info(Elemental ENABLE_ELEMENTAL "compiles parallel linear-algebra library Elemental as part of MADNESS")

# Configure options ============================================================

option(ENABLE_GENTENSOR "Enable generic tensor support" OFF)
add_feature_info(GENTENSOR ENABLE_GENTENSOR "enables use of MRA Function compression that allows computing in 6 dimensions")

if(ENABLE_GENTENSOR)
  add_definitions(-DUSE_GENTENSOR)
endif()
set(TENSOR_USE_GENTENSOR ${ENABLE_GENTENSOR} CACHE BOOL "enable generic tensors")

option(ENABLE_TASK_PROFILER
    "Enable task profiler that collects per-task start and stop times." OFF)
add_feature_info(TASK_PROFILER ENABLE_TASK_PROFILER "supports task-level tracing of program execution")
set(MADNESS_TASK_PROFILING ${ENABLE_TASK_PROFILER} CACHE BOOL
    "Enable task profiler that collects per-task start and stop times.")

option(ENABLE_WORLD_PROFILE "Enables profiling" OFF)
add_feature_info(WORLD_PROFILE ENABLE_WORLD_PROFILE "supports simple profiling of MADworld runtime")
set(WORLD_PROFILE_ENABLE ${ENABLE_WORLD_PROFILE} CACHE BOOL 
    "Enables world profiling")

option(ENABLE_MEM_STATS "Gather memory statistics (expensive)" OFF)
add_feature_info(MEM_STATS ENABLE_MEM_STATS "gather memory statistics (expensive)")
set(WORLD_GATHER_MEM_STATS ${ENABLE_MEM_STATS} CACHE BOOL "Gather memory statistics (expensive)")

option(ENABLE_MEM_PROFILE "Turn on instrumented memory profiling (print_meminfo)" OFF)
add_feature_info(MEM_PROFILE ENABLE_MEM_PROFILE "instrumented memory profiling")
set(WORLD_MEM_PROFILE_ENABLE ${ENABLE_MEM_PROFILE} CACHE BOOL "Turn on instrumented memory profiling (print_meminfo)")

option(ENABLE_TENSOR_BOUNDS_CHECKING
    "Enable checking of bounds in tensors ... slow but useful for debugging" OFF)
add_feature_info(TENSOR_BOUNDS_CHECKING ENABLE_TENSOR_BOUNDS_CHECKING
    "Enable checking of bounds in tensors ... slow but useful for debugging")
set(TENSOR_BOUNDS_CHECKING ${ENABLE_TENSOR_BOUNDS_CHECKING} CACHE BOOL
    "Enable checking of bounds in tensors ... slow but useful for debugging")

option(ENABLE_TENSOR_INSTANCE_COUNT
    "Enable counting of allocated tensors for memory leak detection" OFF)
add_feature_info(TENSOR_INSTANCE_COUNT ENABLE_TENSOR_INSTANCE_COUNT
    "Enable counting of allocated tensors for memory leak detection")
set(TENSOR_INSTANCE_COUNT CACHE BOOL
    "Enable counting of allocated tensors for memory leak detection")

option(ENABLE_SPINLOCKS
    "Enables use of spinlocks instead of mutexes (faster unless over subscribing processors)" ON)
add_feature_info(SPINLOCKS ENABLE_SPINLOCKS
    "Enables use of spinlocks instead of mutexes (faster unless over subscribing processors)")
set(USE_SPINLOCKS ${ENABLE_SPINLOCKS} CACHE BOOL
    "Enables use of spinlocks instead of mutexs (faster unless over subscribing processors)")

option(ENABLE_NEVER_SPIN
    "Disables use of spinlocks (notably for use inside virtual machines)" OFF)
add_feature_info(NEVER_SPIN ENABLE_NEVER_SPIN
    "Disables use of spinlocks (notably for use inside virtual machines)")
set(NEVER_SPIN ${ENABLE_NEVER_SPIN} CACHE BOOL
    "Disables use of spinlocks (notably for use inside virtual machines)")

option(ENABLE_BSEND_ACKS 
    "Use MPI Send instead of MPI Bsend for huge message acknowledgements" ON)
add_feature_info(BSEND_ACKS ENABLE_BSEND_ACKS
    "Use MPI Send instead of MPI Bsend for huge message acknowledgements")
set(MADNESS_USE_BSEND_ACKS ${ENABLE_BSEND_ACKS} CACHE BOOL
    "Use MPI Send instead of MPI Bsend for huge message acknowledgements")

option(ENABLE_UNITTESTS "Enables unit tests targets" ON)
add_feature_info(UNITTESTS ENABLE_UNITTESTS
    "Enables unit tests targets")

set(FORTRAN_INTEGER_SIZE 4 CACHE STRING "The fortran integer size (4 or 8 bytes) used for BLAS and LAPACK function calls")
if(NOT (FORTRAN_INTEGER_SIZE EQUAL 4 OR FORTRAN_INTEGER_SIZE EQUAL 8))
  message(FATAL_ERROR "Incorrect fortran integer size '${FORTRAN_INTEGER_SIZE}'\n"
                       "FORTRAN_INTEGER_SIZE must be equal to 4 or 8")
endif()
add_feature_info("FORTRAN_INTEGER_SIZE=${FORTRAN_INTEGER_SIZE}" TRUE "assumes Fortran integers to be ${FORTRAN_INTEGER_SIZE} bytes long")

if (CMAKE_BUILD_TYPE STREQUAL Release OR
    CMAKE_BUILD_TYPE STREQUAL RelWithDebInfo OR
    CMAKE_BUILD_TYPE STREQUAL MinSizeRel)
  set (DEFAULT_ASSERTION_TYPE "disable")
else ()
  set (DEFAULT_ASSERTION_TYPE "throw")
endif()
set(ASSERTION_TYPE ${DEFAULT_ASSERTION_TYPE} CACHE STRING "Define MADNESS assertion behavior (abort|assert|disable|throw)")
if(ASSERTION_TYPE STREQUAL "abort")
  set(MADNESS_ASSERTIONS_ABORT 1)
elseif(ASSERTION_TYPE STREQUAL "assert")
  set(MADNESS_ASSERTIONS_ASSERT 1)
elseif(ASSERTION_TYPE STREQUAL "disable")
  set(MADNESS_ASSERTIONS_DISABLE 1)
elseif(ASSERTION_TYPE STREQUAL "throw")
  set(MADNESS_ASSERTIONS_THROW 1)
else()
  message(WARNING "Unsupported ASSERTION_TYPE '${ASSERTION_TYPE}'")
  set(ASSERTION_TYPE "throw")
  set(MADNESS_ASSERTIONS_THROW 1)
endif()
message(STATUS "Assertion type: ${ASSERTION_TYPE}")
add_feature_info("ASSERTION_TYPE=${ASSERTION_TYPE}" TRUE "controls how MADNESS assertions (MADNESS_ASSERT) are handled")

set(MPI_THREAD "multiple" CACHE STRING "Thread level for MPI (multiple|serialized)")
if(MPI_THREAD STREQUAL "multiple")
  set(MADNESS_MPI_THREAD_LEVEL "MPI_THREAD_MULTIPLE")
elseif(MPI_THREAD STREQUAL "serialized")
  set(MADNESS_MPI_THREAD_LEVEL "MPI_THREAD_SERIALIZED")
  if (ENABLE_ELEMENTAL)
    message (FATAL_ERROR "Use of Elemental precludes MPI_THREAD=serialized, must use MPI_THREAD=multiple")
  endif (ENABLE_ELEMENTAL)
else()
  message(FATAL_ERROR "Invalid value for MPI_THREAD '${MPI_THREAD}'; valid values are 'multiple' or 'serialized'")
endif()
add_feature_info("MPI_THREAD=${MPI_THREAD}" TRUE "controls the level of thread-safety support in MPI")

# Enable support for shared libraries ==========================================

get_property(SUPPORTS_SHARED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS "Enable shared libraries" ON
      "SUPPORTS_SHARED" OFF)
if(BUILD_SHARED_LIBS)
  set(BLA_STATIC FALSE)
  set(CMAKE_MACOSX_RPATH TRUE)
else()
  set(BLA_STATIC TRUE)
  set(CMAKE_MACOSX_RPATH FALSE)
endif()

set(CMAKE_SKIP_RPATH FALSE)
set(CMAKE_SKIP_BUILD_RPATH  FALSE)
set(CMAKE_SKIP_INSTALL_RPATH FALSE)

# Get host and platform information ============================================

if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
  set(ON_A_MAC 1)
  # look for frameworks and appbundles last
  set(CMAKE_FIND_FRAMEWORK LAST)
  set(CMAKE_FIND_APPBUNDLE LAST)
endif()

if($ENV{USERNAME})
set(MADNESS_CONFIGURATION_USER "$ENV{USERNAME}")
elseif($ENV{USER})
set(MADNESS_CONFIGURATION_USER "$ENV{USER}")
else()
set(MADNESS_CONFIGURATION_USER "$ENV{USER}")
endif()
cmake_host_system_information(RESULT MADNESS_CONFIGURATION_HOST QUERY HOSTNAME)
string(TIMESTAMP MADNESS_CONFIGURATION_DATE)

set(MAD_BIND_DEFAULT "-1 -1 -1" CACHE STRING "The default binding for threads")

# Check if the target platform is CRAY XE
check_cxx_source_compiles(
    "
    #ifndef __CRAYXE
    #error choke me
    #endif
    int main() { return 0; }
    " HAVE_CRAYXE)
# Check if the target platform is CRAY XE
check_cxx_source_compiles(
    "
    #ifndef __CRAYXT
    #error choke me
    #endif
    int main() { return 0; }
    " HAVE_CRAYXT)
if(HAVE_CRAYXE)
  set(AMD_QUADCORE_TUNE ON CACHE BOOL "Target for tuning mtxmq kernels")
  set(USE_SPINLOCKS ON CACHE BOOL 
      "Enables use of spinlocks instead of mutexs (faster unless over subscribing processors)" FORCE)
  set(MAD_BIND_DEFAULT "1 0 2" CACHE STRING "The default binding for threads" FORCE)
  set(MPI_C_COMPILER cc CACHE STRING "CRAY MPI C compiler")
  set(MPI_CXX_COMPILER CC CACHE STRING "CRAY MPI C++ compiler")
endif()

# Check if the target platform is BG/P
check_cxx_source_compiles(
    "
    #ifndef __bgp__
    #error choke me
    #endif
    int main() { return 0; }
    " HAVE_IBMBGP)

# Check if the target platform is BG/Q
check_cxx_source_compiles(
    "
    #ifndef __bgq__
    #error choke me
    #endif
    int main() { return 0; }
    " HAVE_IBMBGQ)

if(HAVE_IBMBGQ OR HAVE_IBMBGP)
  set(USE_SPINLOCKS ON CACHE BOOL

=== cmake/Makefile ===
CMAKE := cmake-3.5.1
URL := https://cmake.org/files/v3.5/$(CMAKE).tar.gz
PREFIX := $(PWD)

all: cmake

wget := $(shell wget 2>/dev/null)
curl := $(shell curl 2>/dev/null)

ifneq  ($(wget), )
download := wget $(URL) -O $(CMAKE).tar.gz
else
download := curl $(URL) -o $(CMAKE).tar.gz
endif


$(CMAKE).tar.gz:
	$(download)

.PHONY: cmake
cmake: $(CMAKE).tar.gz
	tar -xzf $(CMAKE).tar.gz
	cd ./$(CMAKE)
	cd $(CMAKE) && ./configure --prefix=$(PREFIX) # --system-curl
	cd $(CMAKE) && make install

=== doc/CMakeLists.txt ===
# doc

if(DOXYGEN_FOUND)
  set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES html latex *~)

  add_custom_target(docs
    COMMAND ${DOXYGEN_EXECUTABLE} doxygen.cfg)
  
  install(DIRECTORY html 
      DESTINATION "${MADNESS_INSTALL_DOCDIR}" OPTIONAL
      COMPONENT docs)
endif()

=== src/CMakeLists.txt ===
# src

add_subdirectory(madness)
add_subdirectory(apps)
add_subdirectory(examples)

install(FILES madness.h
    DESTINATION "${MADNESS_INSTALL_INCLUDEDIR}"
    COMPONENT madness)

=== src/apps/CMakeLists.txt ===
# src/apps

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
  
add_subdirectory(chem)
add_subdirectory(tdse)
add_subdirectory(moldft)
#add_subdirectory(exciting)
#add_subdirectory(hf)
#add_subdirectory(ii)
#add_subdirectory(interior_bc)
#add_subdirectory(nick)
#add_subdirectory(polar)

=== src/examples/CMakeLists.txt ===
# src/examples

set(EXAMPLE_SOURCES
    pno h2dft hedft hello hatom_energy h2 he tdse_example heat heat2 csqrt 
    sdf_shape_tester test_gmres tdse1d vnucso nonlinschro sininteg functionio 
    dataloadbal hatom_1d binaryop dielectric hehf 3dharmonic testsolver
    testspectralprop dielectric_external_field mp2 tiny oep h2dynamic newsolver
    tdhf cc2 nemo helium_exact density_smoothing siam_example)
 
if(LIBXC_FOUND)
  list(APPEND EXAMPLE_SOURCES hefxc)
endif()

# Create executables for example applications
foreach(example ${EXAMPLE_SOURCES})
  add_executable(${example} ${example}.cc)
  target_link_libraries(${example} MADchem)
endforeach()

=== src/madness/CMakeLists.txt ===
# src/madness

# Add source subdirectories
add_subdirectory(external)

if (MADNESS_HAS_ELEMENTAL_EMBEDDED)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external/elemental/include
      ${CMAKE_CURRENT_BINARY_DIR}/external/elemental/include)
elseif (MADNESS_HAS_ELEMENTAL)
  include_directories(${ELEMENTAL_SOURCE_DIR}/include
      ${ELEMENTAL_SOURCE_DIR}/external/suite_sparse/include
      ${ELEMENTAL_BINARY_DIR}/include)
endif ()

add_subdirectory(world)
add_subdirectory(misc)
add_subdirectory(tensor)
add_subdirectory(mra)

# Create the super library that contains all MADNESS libraries
add_library(madness
    $<TARGET_OBJECTS:MADworld-obj> $<TARGET_OBJECTS:MADmisc-obj>
    $<TARGET_OBJECTS:MADtensor-obj> ${MADTENSOR_MTXMQ_OBJ}
    $<TARGET_OBJECTS:MADlinalg-obj> $<TARGET_OBJECTS:MADmuparser-obj>
    $<TARGET_OBJECTS:MADtinyxml-obj> $<TARGET_OBJECTS:MADmra-obj>)

# Set the dependencies for the MADworld library
if(CXX11_COMPILE_FLAG)
  target_compile_options(madness INTERFACE $<INSTALL_INTERFACE:${CXX11_COMPILE_FLAG}>)
endif()
if(CMAKE_SYSTEM_NAME MATCHES "Darwin")
  target_link_libraries(madness PUBLIC "-Wl,-no_pie")
endif()
if(GPERFTOOLS_FOUND)
  target_include_directories(madness PUBLIC ${GPERFTOOLS_INCLUDE_DIRS})
  target_link_libraries(madness PUBLIC ${GPERFTOOLS_LIBRARIES})
endif()
if(LIBUNWIND_FOUND AND NOT GPERFTOOLS_LIBRARIES MATCHES "unwind")
  target_include_directories(madness PUBLIC ${LIBUNWIND_INCLUDE_DIRS})
  target_link_libraries(madness PUBLIC ${LIBUNWIND_LIBRARIES})
endif()
if(ELEMENTAL_FOUND)
  target_link_libraries(madness PUBLIC ${ELEMENTAL_PACKAGE_NAME})
endif()
if(PAPI_FOUND)
  target_include_directories(madness PUBLIC ${PAPI_INCLUDE_DIRS})
  target_link_libraries(madness PUBLIC ${PAPI_LIBRARIES})
endif()
if(TBB_FOUND)
  target_include_directories(madness PUBLIC ${TBB_INCLUDE_DIRS})
  if(TBB_USE_DEBUG AND TBB_LIBRARIES_DEBUG)
    target_compile_definitions(madness PUBLIC "${TBB_COMPILE_FLAGS_DEBUG}")
    target_link_libraries(madness PUBLIC ${TBB_LIBRARIES_DEBUG})
  else()
    target_link_libraries(madness PUBLIC ${TBB_LIBRARIES_RELEASE})
  endif()
endif()
if(PARSEC_FOUND)
  target_include_directories(madness PUBLIC ${PARSEC_INCLUDE_DIRS})
  target_link_libraries(madness PUBLIC ${PARSEC_LIBRARIES} ${PARSEC_LIBRARIES_DEP}  ${PARSEC_LIBRARY_DIRS_DEP_FLAGS})
endif()
if(MPI_FOUND)
  target_include_directories(madness PUBLIC ${MPI_INCLUDE_PATH})
  target_compile_definitions(madness PUBLIC -DMPICH_SKIP_MPICXX=1 -DOMPI_SKIP_MPICXX=1)
  target_compile_options(madness PUBLIC "${MPI_COMPILE_FLAGS}")
  target_link_libraries(madness PUBLIC ${MPI_LINK_FLAGS})
  target_link_libraries(madness PUBLIC ${MPI_LIBRARIES})
endif()
if(HAVE_IBMBGQ OR HAVE_IBMBGP)
  target_link_libraries(madness PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/new_mtxmq/bests/libMADMTXM.a)
endif()
target_link_libraries(madness PUBLIC ${LAPACK_LIBRARIES})
target_link_libraries(madness PUBLIC ${CMAKE_THREAD_LIBS_INIT})

# Add common header files and madness library to the install list
install(TARGETS madness EXPORT madness
    COMPONENT madness
    LIBRARY DESTINATION "${MADNESS_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${MADNESS_INSTALL_LIBDIR}"
    INCLUDES DESTINATION "${MADNESS_INSTALL_INCLUDEDIR}")
install(FILES constants.h fortran_ctypes.h madness_config.h ${CMAKE_CURRENT_BINARY_DIR}/config.h
    DESTINATION "${MADNESS_INSTALL_INCLUDEDIR}/madness"
    COMPONENT common)
add_custom_target(install-common
     COMMAND ${CMAKE_COMMAND} -DCOMPONENT=common -P ${CMAKE_BINARY_DIR}/cmake_install.cmake
     COMMENT "Installing common library components")

=== src/apps/chem/CMakeLists.txt ===
# src/apps/chem

add_definitions(-DMRA_CHEMDATA_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\")

# Set the CHEM sources and header files
set(MADCHEM_HEADERS
    correlationfactor.h molecule.h molecularbasis.h corepotential.h atomutil.h
    SCF.h xcfunctional.h mp2.h nemo.h potentialmanager.h gth_pseudopotential.h
    molecular_optimizer.h projector.h TDA.h TDA_XC.h TDA_guess.h TDA_exops.h
    SCFOperators.h CCOperators.h CCStructures.h CC2.h CISOperators.h
    electronic_correlation_factor.h cheminfo.h vibanal.h)
set(MADCHEM_SOURCES
    correlationfactor.cc molecule.cc molecularbasis.cc corepotential.cc
    atomutil.cc lda.cc cheminfo.cc distpm.cc SCF.cc gth_pseudopotential.cc 
    nemo.cc mp2.cc SCFOperators.cc TDA.cc TDA_XC.cc CC2.cc CCOperators.cc 
    CISOperators.cc vibanal.cc)
if(LIBXC_FOUND)
  list(APPEND MADCHEM_SOURCES xcfunctional_libxc.cc)
else()
  list(APPEND MADCHEM_SOURCES xcfunctional_ldaonly.cc)
endif()

# Create the MADchem library
add_mad_library(chem MADCHEM_SOURCES MADCHEM_SOURCES "mra" "chem/")

# Add dependencies for MADchem
target_include_directories(MADworld PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/apps/>)
if(LIBXC_FOUND)
  target_include_directories(MADchem PUBLIC ${LIBXC_INCLUDE_DIRS})
  target_link_libraries(MADchem PUBLIC ${LIBXC_LIBRARIES})
endif()

# Add executables
add_executable(plotxc plotxc.cc xcfunctional.h)
target_link_libraries(plotxc MADchem)

# Install files
install(FILES sto-3g sto-6g 6-31g coredata/mcp coredata/mcp2 coredata/mcp_guess
    DESTINATION "${MADNESS_INSTALL_DATADIR}"
    COMPONENT chem)

# Add unit tests    
if(ENABLE_UNITTESTS)
  
  # The list of unit test source files
  set(CHEM_TEST_SOURCES test_SCFOperators.cc test_dft.cc)
  
  add_unittests(chem CHEM_TEST_SOURCES "MADchem;MADgtest")
  
  # Create other test executables not included in the unit tests
  set(CHEM_OTHER_TESTS testxc)
  foreach(_test ${CHEM_OTHER_TESTS})  
    add_executable(${_test} EXCLUDE_FROM_ALL ${_test}.cc)
    target_link_libraries(${_test} MADchem)
  endforeach()
  
endif()

=== src/apps/exciting/CMakeLists.txt ===
# src/apps/exciting

add_executable(wannier wannier.cc)
target_link_libraries(wannier 
    exciting.a fftlib.a 
    /opt/intel/fce/10.1.015/lib/libifcore.a 
    /opt/intel/fce/10.1.015/lib/libirc.a 
    /opt/intel/fce/10.1.015/lib/libimf.a 
    /opt/intel/fce/10.1.015/lib/libsvml.a
    MADmra)

=== src/apps/hf/CMakeLists.txt ===
# src/apps/hf

set(HARTREEFOCK_HEADERS 
    dft.h eigsolver.h poperator.h util.h lda.h electronicstructureparams.h)
set(HARTREEFOCK_SOURCES eigsolver.cc dft.cc)

# Create HartreeFock library
add_library(HartreeFock 
    ${HARTREEFOCK_SOURCES} ${HARTREEFOCK_HEADERS})
target_link_libraries(HartreeFock PUBLIC MADchem)

# Create executables

add_executable(test_hf test_hf.cc)
target_link_libraries(test_hf HartreeFock)

add_executable(test_he test_he.cc)
target_link_libraries(test_he HartreeFock)

add_executable(test_be test_be.cc)
target_link_libraries(test_he HartreeFock)

add_executable(test_hydro test_hydro.cc)
target_link_libraries(test_hydro HartreeFock)

add_executable(test_lattice test_lattice.cc)
target_link_libraries(test_lattice HartreeFock)

add_executable(test_coulomb test_coulomb.cc)
target_link_libraries(test_coulomb HartreeFock)

add_executable(test_comm test_comm.cc)
target_link_libraries(test_comm HartreeFock)

add_executable(testconv testconv.cc)
target_link_libraries(testconv HartreeFock)

add_executable(test_xc test_xc.cc)
target_link_libraries(test_xc HartreeFock)

add_executable(esolver solver_driver.cc mentity.cc)
target_link_libraries(esolver HartreeFock)

=== src/apps/ii/CMakeLists.txt ===
# src/apps/ii

add_executable(testsystolic testsystolic.cc)
target_link_libraries(testsystolic MADmra)

add_executable(eigen_solver eigen_solver.cc)
target_link_libraries(eigen_solver MADmra)

add_executable(localize_boys localize_boys.cc)
target_link_libraries(localize_boys MADmra)

add_executable(tensor_training tensor_training.cc)
target_link_libraries(tensor_training MADmra)

#install(TARGETS testsystolic eigen_solver localize_boys tensor_training
#    DESTINATION "${MADNESS_INSTALL_BINDIR}")

=== src/apps/interior_bc/CMakeLists.txt ===
# src/apps/interior_bc

add_executable(embedded_dirichlet embedded_dirichlet.cc)
target_link_libraries(embedded_dirichlet MADmra)

#install(TARGETS embedded_dirichlet
#    DESTINATION "${MADNESS_INSTALL_BINDIR}")

=== debian/changelog ===
madness (0.10.1~gite4aa500e-10) unstable; urgency=medium

  * debian/patches/disable_pie.patch: New patch, disables PIE, taken from
    upstream commit f625ad51.
  * debian/rules (DEB_BUILD_MAINT_OPTIONS): Comment out variable again.

 -- Michael Banck <mbanck@debian.org>  Fri, 30 Dec 2016 18:02:11 +0100

madness (0.10.1~gite4aa500e-9) unstable; urgency=medium

  * debian/rules (override_dh_auto_test): Reenable tests on i386 again.
  * debian/rules (DEB_BUILD_MAINT_OPTIONS): Disable pie.

 -- Michael Banck <mbanck@debian.org>  Fri, 30 Dec 2016 01:16:31 +0100

madness (0.10.1~gite4aa500e-8) unstable; urgency=medium

  * debian/control (Build-Depends): Added libxc-dev.
  * debian/patches/cmake_mraplot_install.patch: New patch, excludes the mraplot
    utility from being exported as a CMake target.

 -- Michael Banck <mbanck@debian.org>  Thu, 29 Dec 2016 16:00:05 +0100

madness (0.10.1~gite4aa500e-7) unstable; urgency=medium

  * debian/libmadness-dev.install: No longer include the pkgconfig file, as it
    is not created/installed by the CMake build.
  * debian/patches/cmake_installdir.patch: New patch, installs the cmake module
    files under MADNESS_INSTALL_LIBDIR.
  * debian/changelog (Build-Depends): Add libtbb-dev.
  * debian/patches/relax_tbb_version_check.patch: New patch, relaxes the
    version requirement for TBB.

 -- Michael Banck <mbanck@debian.org>  Thu, 29 Dec 2016 10:31:54 +0100

madness (0.10.1~gite4aa500e-6) unstable; urgency=medium

  * debian/rules (override_dh_auto_configure): Set MADNESS_INSTALL_LIBDIR
    rather than CMAKE_INSTALL_LIBDIR.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Dec 2016 21:22:25 +0100

madness (0.10.1~gite4aa500e-5) unstable; urgency=medium

  * debian/rules (DEB_HOST_MULTIARCH): New variable.
  * debian/rules (override_dh_auto_configure): Set CMAKE_INSTALL_LIBDIR.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Dec 2016 18:58:14 +0100

madness (0.10.1~gite4aa500e-4) unstable; urgency=medium

  * debian/control (Build-Depends): Replaced autoconf, automake and
    autotools-dev with cmake and python.
  * debian/rules: Overhaul for CMake.
  * debian/rules: Removed parallel flag for dh.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Dec 2016 15:50:10 +0100

madness (0.10.1~gite4aa500e-3) unstable; urgency=medium

  * debian/rules (override_dh_auto_clean): Remove some more leftover files.
  * debian/control (Build-Depends): Added pkg-config.
  * debian/patches/revert-225c3977.patch: Removed, no longer needed.
  * debian/control (Build-Depends): Replaced mpi-default-dev and
    mpi-default-bin with libmpich-dev.
  * debian/rules: No longer include /usr/share/mpi-default-dev/debian_defaults.
  * debian/rules (override_dh_auto_configure): Pass MPI link libraries via LIBS
    variable.

 -- Michael Banck <mbanck@debian.org>  Tue, 27 Dec 2016 16:22:57 +0100

madness (0.10.1~gite4aa500e-2) unstable; urgency=medium

  * debian/patches/blaslapack_handle_empty_LIBS.patch: New patch, avoids
    leading whitespace in LIBS variabls, as cmake chokes on it when seeing it
    exported in madness-config.cmake.

 -- Michael Banck <mbanck@debian.org>  Mon, 26 Dec 2016 13:38:56 +0100

madness (0.10.1~gite4aa500e-1) unstable; urgency=medium

  * New upstream snapshot.
  * debian/patches/revert-225c3977.patch: New patch, reverts commit 225c3977,
    which causes trouble with autogen.sh.

 -- Michael Banck <mbanck@debian.org>  Thu, 22 Dec 2016 13:47:29 +0100

=== debian/control ===
Source: madness
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>, Graham Inggs <ginggs@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libblas-dev,
               liblapack-dev,
               libmpich-dev,
               libtbb-dev,
               libxc-dev,
               pkg-config,
               python
Standards-Version: 3.9.8
Homepage: https://github.com/m-a-d-n-e-s-s/madness
Vcs-Browser: https://anonscm.debian.org/viewvc/debichem/unstable/madness/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/madness/

Package: libmadness-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Numerical Environment for Scientific Simulation (development files)
 MADNESS (Multiresolution Adaptive Numerical Environment for Scientific
 Simulation) provides a high-level environment for the solution of integral and
 differential equations in many dimensions using adaptive, fast methods with
 guaranteed precision based on multi-resolution analysis and novel separated
 representations. There are three main components to MADNESS. At the lowest
 level is a new petascale parallel programming environment that increases
 programmer productivity and code performance/scalability while maintaining
 backward compatibility with current programming tools such as MPI and Global
 Arrays. The numerical capabilities built upon the parallel tools provide a
 high-level environment for composing and solving numerical problems in many
 (1-6+) dimensions. Finally, built upon the numerical tools are new
 applications with initial focus upon chemistry, atomic and molecular physics,
 material science, and nuclear structure.
 .
 This package contains the static libraries and the header files.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem cmake

override_dh_auto_clean:
	-dh_auto_clean
	rm -f config/missing config/config.sub config/depcomp config/config.guess config/test-driver config/compile config/install-sh config/lt* config/libtool.m4
	rm -f aclocal.m4 configure doc/doxygen.cfg src/madness/config.h.in
	rm -f src/madness/mra/fplot.dat src/madness/mra/opf.dat src/madness/mra/opfplot.dat src/madness/mra/testline1  src/madness/mra/testline2 src/madness/mra/testline3 src/madness/mra/testplot src/madness/world/test.dat src/madness/world/testme.ar
	rm -f doc/Makefile src/apps/exciting/Makefile src/apps/hf/Makefile src/apps/interior_bc/Makefile src/apps/nick/Makefile src/apps/polar/Makefile
	rm -f src/examples/compiler/Makefile-prog src/examples/compiler/Makefile-prog.in src/madness/world/log.00000
	find . -name "Makefile.in" | xargs rm -f

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=OFF -DMADNESS_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH),armel))
	-dh_auto_test || cat src/madness/world/test-suite.log
endif
endif

=== debian/watch ===
version=3
https://github.com/m-a-d-n-e-s-s/madness/releases .*/madness-([\d.]+)\.tar\.gz$

## madness 0.10.1%2Bgit20200818.eee5fd9f

=== src/madness/external/tinyxml/CMakeLists.txt ===
# src/madness/external/tinyxml

set(MADTINYXML_HEADERS tinystr.h tinyxml.h)
set(MADTINYXML_SOURCES tinystr.cc tinyxml.cc tinyxmlerror.cc tinyxmlparser.cc)

# Create the MADtinyxml library
add_mad_library(tinyxml MADTINYXML_SOURCES MADTINYXML_HEADERS "dummy" "madness/external/tinyxml/")

=== debian/watch ===
version=3
https://github.com/m-a-d-n-e-s-s/madness/tags .*/v?([\d.]+)\.tar\.gz$
